settings.outformat="pdf";
defaultpen(fontsize(10pt));
size(9cm,0);

pair c1=(0,0);
real r=1;
real shrink=0.7;

pen myblue=rgb(0.8,0.75,1);
pen mygreen=rgb(0.8,1,0.75);

path pspvenn=circle(c1,1);
fill(pspvenn, myblue);

path npvenn=shift(0,0.2)*scale(shrink)*pspvenn;

draw(pspvenn);
draw(npvenn);
draw((0,0.44),L=Label("\textbf{PSPACE-complete}"));
draw((0,-0.7),L=Label("\textbf{NP-hard}"));

pair relmidpoint(path p, path g, real t, real w){
	return relpoint(p,t)*(1-w)+relpoint(g,t)*w;
	}

path games=shift(-shrink,-0.1)*scale(4/3,2/5)*circle(c1,1); 

real[][] xs=intersections(pspvenn,games);
path badgames=subpath(games,xs[0][1],xs[1][1]) & subpath(pspvenn,xs[1][0],xs[0][0]) & cycle;
path separator=subpath(pspvenn,xs[1][0],xs[0][0]);

path goodgames=subpath(games,0,xs[1][1]) & subpath(pspvenn,xs[1][0],xs[0][0]) & subpath(games,xs[0][1],reltime(games,1)) & cycle;
fill(goodgames,mygreen+opacity(0.5));
fill(badgames,mygreen);

Label goodlabel=Label(minipage("``good'' games"));
Label badlabel=Label(minipage("``bad'' games"));
real txth=-0.1;
draw((-shrink-0.6,txth),L=badlabel);
draw((.22,txth),L=goodlabel);

draw(games);

draw(separator, red+dashed+linewidth(1.5pt));
